qingy 1.0.0 (07 Dec 2010):
- Made qingy work with PAM consolekit.

qingy 0.9.9 (11 May 2009):
- Reverted change in stdin management that interfered with DBus.

qingy 0.9.8 (27 Apr 2009):
- Fixed bug introduced in 0.9.7 and triggered when searching for X sessions
	outside /etc/X11/Sessions and detected session path is a full path.
	Thanks to Riccardo Stagni for the patch.
- Fixed bug, found by 'Tom',
  that made qingy sometimes improperly set focus to both session
  and username (or password) fields.
- Prevent qingy from crashing in case of error when parsing
  settings files: revert to text mode instead.
- Removed need of password to autologin feature.
  Patch proposed by Florent Bondoux <florent.bondoux@resel.fr>
- Improved qingy main process and GUI communication. Now login times
  in case of correct authentication are reduced...
  Patch proposed by Florent Bondoux <florent.bondoux@resel.fr>
- Added feature, disabled by default, to check current runlevel
  to prevent qingy from showing its GUI or starting a session
  during a system shutdown or restart.
- Made GUI messages user definable in theme file.
- Made several message timeouts user configurable in theme file.
- Other small enhancements and fixes, some contributed by Florent Bondoux
  <florent.bondoux@resel.fr>

qingy 0.9.7 (08 Jul 2008):
- Added '-br' to default X args.
- No longer try to create /etc/X11/Sessions if it was not found

qingy 0.9.6 (26 Apr 2007):
- Detached qingy from its controlling tty when starting sessions.
- qingy no longer tries to kill its GUI as it should not hang any more.
- Fixed bug that made shells other that zsh be invoked with a double '-';
  that is --bash instead of -bash, which is the correct form for login
  shell invocation.
- Added proper escaping for session names, removed quoting around them.
- Added support for selecting whether to start the X server in the same
  tty qingy is running in (default for qingy), or in an unused one (default for startx).

qingy 0.9.5 (17 Jan 2007):
- Changed again the way qingy fires up the shell: now it
  is started as a login shell regardless of the session type, 
  text or graphic, pure shell of program...
- Made textbox mouse clicks position the text cursor according
  to where in the text the user clicked.
- Wiped out matrix screensaver as it used a font with licensing issues.
- Other small fixes and enhancements.

qingy 0.9.4 (21 Dec 2006):
- Fixed zsh not being invocated as a login shell.
- Rationalized when to start a shell as a login shell or not.
- Fixed an issue with dbus.
- Updated qingy PAM file for Gentoo.
- Added capability to change (or disable) mouse cursors in themes:
  now it is possible to set up a global theme cursor, as well as
  different cursors when the mouse passes specific elements.

qingy 0.9.3 (09 Nov 2006):
- Fixed qingy compilation in case user chooses openssl encryption.

qingy 0.9.2 (24 Oct 2006):
- Since shutting DirectFB mode down sometimes fails, due to the fact that
  DirectFB itself may hang somewhere in its bowels when closing graphic mode,
  I wrote some code that performs a low-level reset of the console,
  thus effectively restoring it into an usable state. Now, when qingy has to
  shut down its GUI (and it hangs), it will kill it, reset the console, and go on
  as if nothing had happened :-)
- Fixed shift-tabbing from username to session.
- Removed 'retries' entry from settings file.
- Removed --screensaver command line arg, moved it to settings file.
- Added support for screen power management, now the screen(s) will be
  powered off after a given timeout.
- Fixed a bug that made screen saver pop up immediately when user chose
  to disable it by setting a timeout of 0.
- Small logger improvements; log more events in debug mode.
- Fixed bug that made qingy respawn indefinitely if one chooses syslog
  as the only logging facility.
- Fixed bug that made qingy GUI crash if console was not chosen
  as a logging capability.
- Fixed corrupt matrix screensaver font file.
- Made last session files in user home dirs owned by the
  respective users, and no longer by root...
- Added some code to get available X sessions for those
  distros that do not save them.
- Other fixes and clean-ups.
- DirectFB version 0.9.24 (or higher) is now required to run qingy.

qingy 0.9.1 (24 Aug 2006):
- Argh, all graphics in default theme were currupt! This probably was caused
  by the switch to svn... Fixed it by recovering the files from an older
  qingy tarball.
- Fixed a bug that sometimes made qingy GUI hang on exit.
- Made DirectFB support optional. This means that you can compile and run
  qingy on systems that do not have DirectFB installed. You will not get
  a graphic login, but will be presented a choice of sessions and will
  have access to qingy advanced features like session locking or timeout.

qingy 0.9.0 (03 Aug 2006):
- Because of the following, removed '--verbose' command line argument.
- Added extensive logging capabilities. Now you have the option of having
  qingy log its messages to one (or more) of console, log file, syslog.
  Default is console only. Also, you can specify the log verbosity, it being
  one of ERROR (default, only log errors) or DEBUG (all messages will be logged).
  This should help out those people on which qingy dies with a black screen
  and an unresponsive machine (other than ssh), so that they should now be able
  to see why it is failing on them.
- Allow user (in graphic mode) to select a session by typing the first char
  of its name. Subsequent presses of the same key will bring up any other
  session names that start with the same char, if any exists.
  Code kindly provided by Brian Carter <spakov@users.sourceforge.net>.
- Added support for selecting desired session during text mode login.
  It will also remember latest session just like graphic login.
- Made ./configure option 'enable-x-support' actually work. Thus disabling
  it will make qingy actually compile and work without X installed.
  It will also make X sessions unavailable (even if X is installed)...
- Other small bug fixes.

qingy 0.8.0 (05 Jun 2006):
- Made qingy GUI multithreaded. Now every graphic element on screen has
  one or more threads that handle draws and input events independently.
  This greatly reduces code complexity as well as improving maintainability.
  Also, it paves the road for adding some more elements to qingy GUI,
  like an 'X profile' combo, or a 'host to connect to' one.
- Fixed bug that made main qingy process hang if its gui terminated abnormally,
  when DirectFB is shutting down and gets an invalid address somewhere inside
  its bowels. This made qingy lock up using 100% CPU power. Fortunately this
  happened in text mode so that it was possible to kill the process and go on...
- Fixed "kill qingy" keybinding behaviour. Now it actually
  quits qingy, instead of locking up your machine ;-).

qingy 0.7.4 (04 Apr 2006):
- Added support for wildcards in photo screen saver options. This
  means that you can put something like this in settings file:
  screensaver "photos" =
    "/path/to/images/200*",
    "path/to/other/images/*.jpg"
  Supported wildcards are * for string expansion and ? for single
  char expansion.
- Re-allow for some cleaning before shutting DirectFB mode down.
  Bug signalled and fixed by Masse Nicolas <masse_nicolas@yahoo.fr>
- Added PAM file for debian, provided by Riccardo Stagni.

qingy 0.7.3 (16 Mar 2006):
- Fixed libgcrypt support. Now it is no longer considered experimental,
  and should work as expected :-)
- Fixed session timeout, in case of 'logout' action. Using this feature
  no longer exposes users to possible machine lock-ups. Thus, the whole
  session timeout feature can now be considered production ready, no longer
  experimental.
- Fixed detection of X11 headers and libraries, it should now work
  on those distros that put them under /usr/X11R6.

qingy 0.7.2 (09 Mar 2006):
- SECURITY FIX: fixed bug where session locking did not work if there was
  more than one running session that required it.
- Made running time screen saver less CPU hungry.
- Added support for zsh shell.
- Fixed last login time for 64 bit machines, thanks to Kevin Jamieson.
- Added EXPERIMENTAL session timeout feature, with configurable timeout
  and actions (you can select either 'close your session' or 'lock it').
  Right now, locking your session works, closing it may hang your machine
  (in case of an X session) because qingy might be restarted before X
  finishes shutting down. Try it at your own risk ;-)

qingy 0.7.1 (06 Feb 2006):
- Fixed (again) support for non-PAM authentication.
- Added GPM start/stop scripts for Slackware Linux.
- Added 'no-hardware' to the args I pass to DirectFB. This should solve
  issues and hangs with some buggy drivers (like ATI's).
- Added new values for last_user_policy and last_session_policy
  settings: 'none'. Setting it this way means that qingy will not
  attempt to fetch (and set) latest user and/or session in any way.
- Limit Mobile Pentium 4 specific optimizations to gcc 3.4.x

qingy 0.7.0 (01 Feb 2006):
- SECURITY ENHANCEMENT: made qingy GUI communicate auth data
  to its main process using a fifo instead of an actual file.
- Added support for Fedora Core Linux. This means that I added some magic
  to detect wether Gnome or Kde (or both of course) are installed, so that
  qingy can display them in the sessions list...
- Manage text mode logins internally, without calling 'login'.
  In this case, /etc/issue will be parsed and its contents
  displayed on screen before login prompt.
- Added '-t' command line argument that tells qingy to
  perform a text mode login (no graphics). This will allow users
  to log in using an old-fashioned getty-like mode, but still retain
  qingy advanced features like autologin and session locking.
- Added support for calling a script just before qingy GUI is fired up,
  and one after it is shut down. Useful if DirectFB is picky about your
  machine and you need to do something before/after switching DirectFB
  mode on/off.
- Moved GPM start/stop code to external scripts that are called via
  the feature described above. Currently supported distros are Gentoo
  and Fedora.
- Made X start up in the same tty we logged in instead of switching
  to a new one.
- Made qingy check authentication data only once, in its main
  process. Until now it was once in the GUI and once in the
  main process, leading to potential problems with /etc/securetty
  since the GUI does not live in the same tty as the main process.
- Added support for selecting last session on a per-user or a
  per-tty basis. Previous (and current default) behaviour was
  per-user only. To change it you have to set variable
  last_session_policy in settings file.
- Added support to select wether qingy should calculate last user
  on a global or a per-tty basis. Default will be current
  functionality, i.e. global. To change it you have to set variable
  last_user_policy in settings file.
- Added new settings file variable, x_server_offset.
  This is the offset used to search for an available X server number.
  This number will affect the DISPLAY env variable. 
  Default is 1, setting it to 0 will make buggy OpenGL implementations
  (like the ATI one) work with qingy (read: 3D support), but it will also
  make it impossible to start an X server from a console session using startx
  without passing it extra parameters.
- Added support for Mobile Pentium 4 processors optimization.
- Added EXPERIMENTAL support for GNU libgcrypt as crypto library.
  If you decide to try it out, good luck creating a good keypair!
- Other small enhancements and bug fixes.

qingy 0.6.0 (30 May 2005):
- SECURITY ENHANCEMENT: added support for encrypting communications
  between qingy and its user interface, triggered by new ./configure
  option: --enable-crypto, enabled by default.
- SECURITY ENHANCEMENT: Overwrite memory areas containing sensitive
  user info before quitting...
- SECURITY FIX: now authentication data is passed between
  qingy and its GUI trough a securely created temp file.
- A drop-down mouse menu for sessions has been implemented.
- Added customizable keybindings support
- Because of the above, removed old powerkeys support
- Fixed a rather obscure bug in which login could fail
  even if username and password were correct
- Added new setting in theme file, 'native_resolution', which
  lets you specify the screen resolution the theme was crafted
  for. This way, when qingy encounters a resolution different
  than this one, it will scale all graphic elements so that
  they look the same on all resolutions.
- Added two new font sizes that can be used in theme files:
  'smaller' and 'tiny'.
- Updated handling of utmp/wtmp logging so that chrootkit no longer
  finds deletions in the latter when user logs out.
- Brought tty guardian to a nearly completed state: now it
  checks the tty you came from; if you were logged in as root
  or as same user on the destination tty, it lets you pass,
  otherwise it will ask you to enter either destination user
  or root password. If authentication fails, it will send you
  back to the tty you came from. It also remembers the last
  user who successfully authenticated, so that he will not
  have to authenticate again every time he switches to the
  guarded tty (but if you switch to a tty owned by a third
  user and go back, authentication will be asked again). The
  only drawback is that if you come from an X session in which
  you are logged in as root, it will ask you to authenticate,
  because that situation can not (yet) be distinguished from
  when you come from an unused tty (which is owned by root
  as well)...
- Fixed a number of tty guardian related bugs.
- Other small fixes and clean-ups.


qingy 0.5.3 (11 January 2005):
- Finally the code behind the 'sleep' button has been implemented:
  just set up the 'sleep' variable in config file to the
  command you would like to execute for sleep mode, and
  press the button in qingy...
- Now the directory qingy uses to store its temporary files
  can be customized
- Added support for automatically logging in a user when
  the machine powers up
- Correctly unset the DISPLAY env variable when starting a text
  mode session, in case PAM provided one to us anyway.
- Added support for passing user-defined arguments to the X server.
  To enhance security, as a default we now pass '-nolisten tcp'...
- Added support for AMD Athlon64 processors optimization.
- Fixed support for shadow password authentication...
- Fix stuff so that qingy links correctly against the PAM
  library when compiled as a static binary.
- Session files containing spaces are now supported
- Reworked qingy PAM module to make it work with more distros
  (tested on Fedora, Debian, Gentoo)
- Added support for 'retries' setting in config file
  which allows user to specify how many times qingy
  should try to bring its gui up before reverting
  to text mode...


qingy 0.5.2 (19 Aug 2004):
- Brown paper bag release: fix horrible bug I just introduced not allowing
  to run qingy any more due to incorrect cmd line arguments handling...


qingy 0.5.1 (18 Aug 2004):
- Fixed a bug that prevented qingy from honouring
  tty specific options in config file.
- Fixed a bug that prevented qingy from honouring some
  command line arguments...
- Fix X11 sessions search path for Gentoo linux.
- Code clean ups.


qingy 0.5.0 (17 Aug 2004):
- This new major version finally is able to work-around all issues
  between DirectFB and 2.6 kernels. But make sure to use a kernel 
  >= 2.6.8 and never, ever attempt a 2.6.7 one as it is likely to
	lock up your machine completely. You have been warned ;-)
- High memory usage issues are now solved, now qingy should use
  ~2.5 MB of RAM when user is logged in (instead of ~40MB!)...
- Remove support for the '--black-screen-workaround'
	cmd line arg, as it is no longer needed.


qingy 0.4.1 (28 Jul 2004):
- Added proper support for transparent pixmaps, now qingy
  will honour the transparency instead of faking it by
  making the black pixels transparent...
- New command line argument: '--resolution <xres>x<yres>'.
  Use it if qingy fails to properly detect your framebuffer
  resolution.
- Added support for choosing your favourite X server in settings file
- Fixed theme loading code, now qingy should not crash any more...
- Made sure that if qingy dies horribly during initialization,
  it does it with tty switching enabled so that user is not
  stuck in front of a 'respawning too fast' message...
- Allow for buttons with no action associated to them,
  just use "action = NULL", thanks to a suggestion from
  Dark Liquid (http://www.darkliquid.net/)
- Moved last user file from /etc/qingy/ to /var/lib/misc/
  to comply to the File System Hierarchy Standard.
  Thanks to Jason Andryuk <the_deuce@yahoo.com>
  for poinint this out.
- Accepted a patch from Konstantin Korikov <lostclus@ukr.net>
  that adds new keybindings in text boxes:
  ctrl-h: delete one character
  ctrl-u: delete all characters
  ctrl-j: go to next textbox (same as ENTER)


qingy 0.4.0 (18 March 2004):
- Properly detect framebuffer resolution on qingy startup,
  instead of using directfbrc.qingy, which is no longer necessary:
  you can safely remove it from your system. This also means that
  you no longer need to have the 'fbset' utility to compile qingy.
- Now screensavers are modular; this means that:
  - only the screensaver you chose gets loaded at run time; this
    makes qingy use a little less memory
  - you can roll your own screensaver, without need to recompile qingy
  - you must be careful about the screensaver you install, this
    is effectively an entry point to arbitrary code that would
    run with root privileges (don't say you haven't been warned ;-P )
- Pa0lino added an utility, 'themer', to convert qingy 0.2 series
  theme files to qingy 0.3 theme structure...
- Fixed some bugs in config files parser...
- Added support for writing to /var/log/wtmp; this allows tools
  like 'who', 'w', 'finger' to be able to 'see' users logged
  in with qingy.
- Added option in both setting and theme file to select wether you
  want or not to clear the background image in dialogs like
  "logging in user...".
- Added support for tty specific options. See the new settings file
  for an example on how this works.
- Added a file, /etc/qingy/welcomes, where you can put personalized
  welcome messages (like the 'Greetings, Master...' when you log in
  as root).
- Added session locking support; if you enable this, when you try to
  switch to a qingy-controlled tty whose owner is not your current
  user, you will be asked for the password of that user before being
  allowed to continue. If you are root, of course, you can switch
  to any tty you chose to. Default setting is 'no'. Note: this is
	an EXPERIMENTAL feature, so you are warned. That said, it appears
  to work well, only issue that I know of is that if you log in into
  a text console and later fire up an X server manually, the tty the
  X server is running in is not guarded.
- Made qingy install its stuff in a way that conforms to the file
  system hierarchy standards (themes are now installed to
  /usr/share/qingy/themes, screen savers to
  /usr/lib/qingy/screensavers).
- Now qingy by default creates a bunch of shared libraries and loads
  its stuff only when it is needed. This saves a lot of memory,
  expecially for those qingy processes that are waiting for someone
  to switch to the tty they are running in. This option can be
  disabled with by passing the '--enable-static-build' argument
  to ./configure
- Be nicer to Slackware (and maybe other distros as well ;-)
  This means:
  - qingy now sets also the PATH env variable (otherwise qingy is
    not able to start an X session because xinit is not able to
    find the location of the X server; this is true for Slackware).
  - Slackware puts its X session scripts in /etc/X11/xinit/
    now we honour that, too, following their name pattern "xinitrc.*"
- Screen saver support is now optional (but enabled by default), for
  those security paranoids ;-P


qingy 0.3.0 (09 January 2004):
- New memory allocation/deallocation management
- Unlock vt switching before dying (yes, this was annoying)
- Solved a bug that made qingy crash when you switched to its
  tty after it had been sitting there for some time. Basically
  it opened a file descriptor every second and did not close
  it...
- Now qingy reverts to text mode instead of dying when it
  encounters non-fatal errors in command line parameters or
  settings / theme file...
- Various previously unchecked memory allocations got leashed
- Now qingy parses /etc/inittab to decide what to do when
  user presses ctrl-alt-del (up to now it did nothing).
  Supported stuff: poweroff, halt, reboot, shutdown
  (with -h or -r), as well as just displaying a message
  (echo "your message here").
- Added --disable-lastuser option to tell qingy not do display
  last user name. This way it will always ask for user name.
- Added support for user's own .xsession file (just create a
  .xsession file in your home dir, put there the stuff you
  want to load, and choose "Your .xsession" as session).
- Now background image stays there when attempting to log in,
  during timeouts... It goes away only during screen saver
- Added ./configure option to disable PAM support (--disable-pam)
- Added support in config file to specify a shutdown policy:
  use 'shutdown_policy = everyone' to allow everyone to shutdown
      'shutdown_policy = root' to be asked for root password
      'shutdown_policy = noone' to forbid shutdown completely.
  If this option is not used, qingy defaults to 'everyone'
- Rewrote load_settings.c (and added others ;-P). Now parsing
  of setting and theme files is done via regular expressions.
  I undestand little (but I will ;-P) of that stuff, so all
  the praise goes to Paolino <paolino.gnu@disi.unige.it>...
- Radically changed configuration files structure... too hard
  to explain it all here: see updated documentation for all
  details. In short: all stuff you see on screen can be
  added, removed, moved, changed... you got the point :-)
- Added user-oriented welcome messages. See documentation.
  Thanks, again, to Paolino <paolino.gnu@disi.unige.it>
- Added support for user-provided CFLAGS: just use
  ./configure MY_CFLAGS="your_cflags_here"
  Please note that qingy already tries to set the best
  optimization for your arch in CFLAGS; using the above
  feature overrides those settings... I added this feature
  primarily to use with Gentoo GNU Linux portage system.
- Added info documentation for qingy, thanks (again) to
  Pa0lino... just issue a 'info qingy'!
- Many fixes and clean ups


qingy 0.2.3 (21 October 2003):
- Now qingy locks vt switching when it enters DirectFB mode.
  So it no longer crashes when you switch VT while it is starting
- no longer necessary to use a seed file to select a random theme
  (you can safely remove file /etc/qingy/seed if it exists)
- Added support for text mode sessions
  (just add your session script in /etc/qingy/sessions)
- Moved themes directory to /etc/qingy/themes
  (note that you do not need to change your /etc/qingy/settings)
- Added some code to allow restarting of gpm even if it was
  stopped by a previous session of qingy (that crashed ;-P)
- Removed '--silent' option. Now qingy is silent by default.
  If you still want to get diagnostic messages on stderr
  you have to use the '--verbose' option
- Added photo screen saver (it displays a slide show of photos)
- Added option 'SCREEN_SAVER' to config file. You can specify
  'pixel' or 'photo' to select which screen saver you want
- Added option 'IMAGES_PATH' to config file. Use it to specify 
  a directory containing images to use with photo screen saver.
  Note: you can specify more than one path by putting
  several 'IMAGES_PATH' lines into the config file.
- No longer necessary to start qingy in the first 12 ttys
- Added support for comments is config file.
- A surprise now awaits the rightful master ;-)	
- The usual minor fixes and clean ups


qingy 0.2.2 (29 September 2003):
- Starting X sessions for users with a shell other than bash
  should no longer fail with strange errors
  (this occurred at least with tcsh)
- added support for selecting a random theme
  at startup (just use 'random' as theme name)
- added support for screen savers
- added a screen saver: pixel
- added option to select which framebuffer device to use
- updated text mode login for increased security
- no longer necessary to create a /etc/directfbrc file:
  now qingy creates automatically file /etc/directfbrc.qingy
  (thus other DirectFB apps are unaffected) with
  hopefully the proper resolution already detected.
  Note: you need the 'fbset' program for this.


qingy 0.2.1 (01 September 2003):
- correctly changes tty ownership
- Hopefully solves PAM issues
- Added option to close DirectFB mode before shutting down,
  so that you can see your system shutdown messages
- Added option for hiding last user name
- Added option for hiding password chars completely
- Now ENTER in username field pass control to password
- Now qingy reverts back to text mode login if something
  goes wrong with DirectFB
- Message "Login failed" now appears for 2 seconds
- Various fixes and clean ups (memory leaks, allocation failures...)


qingy 0.2 (18 July 2003):
- Added PAM support
- Added --silent option to avoid diagnostic messages on stderr
- Various clean ups


qingy 0.1.1 (09 July 2003):
- embedded object related functions into object structures themselves
- full theme support
- Changed default theme to the Ant one
- Various clean ups


qingy 0.1 (05 July 2003):
- first public release
